#include <stdio.h>
#include <string.h>

// ακολουθούμε την απλή προσέγγιση και ορίζουμε το
// μέγιστο μέγεθος που θεωρούμε ότι θα έχει μία
// γραμμή του κειμένου
#define LINE_SIZE 1024

/*
 * Η συνάρτηση που εκτυπώνει τις γραμμές του κειμένου
 * που υπάρχει στο αρχείο fileName και περιέχουν το
 * κείμενο word
 */
void showLines(char *fileName, char *word) {
    // δημιουργούμε έναν πίνακα που μπορεί να κρατήσει μια γραμμή κειμένου
    // (μαζί με την αλλαγή γραμμής και τον μηδενικό τερματικό χαρακτήρα)
    char textLine[LINE_SIZE];

    // δοκιμάζουμε να ανοίξουμε το αρχείο με όνομα/path fileName για
    // ανάγνωση (μόνο εφόσον υπάχει) και σε mode κειμένου
    FILE *inputFile = fopen(fileName, "r");
    // ελέγχουμε εάν όντως άνοιξε
    if (inputFile == NULL) {
        // αν όχι εκτυπώνουμε στο stderr σχετικό μήνυμα λάθους
        fprintf(stderr, "Cannot open file '%s' to read it!\n", fileName);
        // τερματίζουμε τη συνάρτηση
        return;
    }

    // όσο διαβάζοντας μια γραμμή από το αρχείο (μέσα στο textLine)
    // δεν τερματίζεται το αρχείο
    while(fgets(textLine, LINE_SIZE, inputFile) != NULL ) {
        // εάν η γραμμή περιέχει τη λέξη word
        if (strstr(textLine, word) /* != 0 */) {
            // εκτυπώνουμε τη γραμμή στην οθόνη
            // (δεν προσθέτουμε αλλαγή γραμμής καθώς η fgets
            // φέρνει μέσα στο κείμενο την αλλαγή γραμμής που
            // υπάρχει στο αρχείο)
            printf("%s", textLine);
        }
    }

    // μετά την ολοκλήρωση της ανάγνωσης κλείνουμε το αρχείο
    fclose(inputFile);
}

int main() {
    showLines("../mytext.txt", "Engine");
    return 0;
}
